Index: trunk/source/Lib/TLibCommon/TComDataCU.cpp
===================================================================
--- trunk/source/Lib/TLibCommon/TComDataCU.cpp	(revision 964)
+++ trunk/source/Lib/TLibCommon/TComDataCU.cpp	(revision 976)
@@ -5164,26 +4584,9 @@
     for(Int i = 0; i < 2; i ++)
     {
-#if ETRIKHU_CLEANUP_H0083
       if ( !m_mergCands[MRG_A1+i].m_bAvailable ) 
-#else
-      Int iCnloop = iPosLeftAbove[i];
-      if ( iCnloop == -1 ) 
-#endif
       {
         continue;
       }
-#if ETRIKHU_CLEANUP_H0083
-#if ETRIKHU_BUGFIX_H0083
       if (ivCandDir[1] == m_mergCands[MRG_A1+i].m_uDir && tmpMV[0]==m_mergCands[MRG_A1+i].m_cMvField[0] && tmpMV[1]==m_mergCands[MRG_A1+i].m_cMvField[1])
-#else
-      Int offset = 0;
-      offset += A1_was_available;
-      offset += B1_was_available;
-      offset += m_mergCands[MRG_B0].m_bAvailable;
-      if (puhInterDirNeighbours[offset] == m_mergCands[MRG_A1+i].m_uDir && pcMvFieldNeighbours[(offset<<1)]==m_mergCands[MRG_A1+i].m_cMvField[0] && pcMvFieldNeighbours[(offset<<1)+1]==m_mergCands[MRG_A1+i].m_cMvField[1])
-#endif
-#else
-      if(puhInterDirNeighbours[iCount] == puhInterDirNeighbours[iCnloop] && pcMvFieldNeighbours[iCnloop<<1]==pcMvFieldNeighbours[(iCount<<1)] && pcMvFieldNeighbours[(iCnloop<<1)+1]==pcMvFieldNeighbours[(iCount<<1)+1])
-#endif
       {
         bRemoveSpa                      = true;
@@ -5193,5 +4596,4 @@
     if(!bRemoveSpa)
     {
-#if ETRIKHU_CLEANUP_H0083
 #if H_3D_NBDV
       tmpMV[0].getMv().setIDVFlag (false);
@@ -5199,21 +4601,5 @@
 #endif
       m_mergCands[MRG_IVDC].setCand( tmpMV, ivCandDir[1], false, false);
-#else
-      rightShiftMergeCandList( pcMvFieldNeighbours, puhInterDirNeighbours, vspFlag, inheritedVSPDisInfo, iCount, (5-iCount), iCount3DV);
-      puhInterDirNeighbours[ iCount ] = ivCandDir[1];
-      if( ( ivCandDir[1] & 1 ) == 1 )
-      {
-        pcMvFieldNeighbours[ iCount<<1    ].setMvField( ivCandMv[ 2 ], ivCandRefIdx[ 2 ] );
-      }
-      if( ( ivCandDir[1] & 2 ) == 2 )
-      {
-        pcMvFieldNeighbours[(iCount<<1)+1 ].setMvField( ivCandMv[ 3 ], ivCandRefIdx[ 3 ] );
-      }
-#if H_3D_NBDV
-      pcMvFieldNeighbours[iCount<<1    ].getMv().setIDVFlag (false);
-      pcMvFieldNeighbours[(iCount<<1)+1].getMv().setIDVFlag (false);
-#endif
-      posIvDC  = iCount;
-#endif
+
       if ( mrgCandIdx == iCount )
         return;
@@ -5243,15 +4629,11 @@
       !bARPFlag &&
 #endif
-#if SHARP_SIMPLE_MERGE_H0062
+#if H_3D
       (nPSW + nPSH > 12) &&
 #endif
-#if RWTH_DBBP_NO_SPU_H0057
+#if H_3D_DBBP
       !bDBBPFlag &&
 #endif
-#if ETRIKHU_CLEANUP_H0083
       xAddVspCand( mrgCandIdx, &cDisInfo, iCount ) )
-#else
-      xAddVspCand( mrgCandIdx, &cDisInfo, iCount, abCandIsInter, pcMvFieldNeighbours, puhInterDirNeighbours, vspFlag, iCount3DV, inheritedVSPDisInfo ) )
-#endif
   {
     return;
@@ -5269,9 +4651,5 @@
 
 #if H_3D
-#if ETRIKHU_CLEANUP_H0083
   iCount += m_mergCands[MRG_A0].m_bAvailable + m_mergCands[MRG_B2].m_bAvailable;
-#else
-  iCount += numA0B2;
-#endif
 #else
   //left bottom
@@ -5347,9 +4725,5 @@
   if(  ivMvPredFlag && iCount < getSlice()->getMaxNumMergeCand() && !getSlice()->getIsDepth() ) 
   {
-#if ETRIKHU_CLEANUP_H0083
     if(xAddIvMRGCand( mrgCandIdx,  iCount, ivCandDir, ivCandMv, ivCandRefIdx ) )
-#else
-    if(xAddIvMRGCand( mrgCandIdx,  iCount, abCandIsInter, pcMvFieldNeighbours, puhInterDirNeighbours, ivCandDir, ivCandMv, ivCandRefIdx, posIvDC, vspFlag, iCount3DV, inheritedVSPDisInfo ) )
-#endif
     {
       return;
@@ -5362,18 +4736,5 @@
   }
 #endif
-
-#if H_3D
-#if !ETRIKHU_CLEANUP_H0083
-  if (iCountHEVC + iCount3DV > getSlice()->getMaxNumMergeCand())
-  {
-    iCount = getSlice()->getMaxNumMergeCand();
-  }
-  else
-  {
-    iCount = iCountHEVC + iCount3DV;
-  }
-  numValidMergeCand = iCount;
-#endif
-#else
+#if !H_3D
   if ( getSlice()->getEnableTMVPFlag())
   {
@@ -5463,5 +4824,5 @@
     }
   }
-  // early termination
+  // early termination  
   if (iCount == getSlice()->getMaxNumMergeCand()) 
   {
@@ -7232,10 +6593,8 @@
 
   TComMv      cDv = depthRefineFlag ? pDInfo->m_acDoNBDV : pDInfo->m_acNBDV; 
-#if SEC_VER_DONBDV_H0103
   if( depthRefineFlag )
   {
     cDv.setVer(0);
   }
-#endif
 
   Int         iBasePosX   = Clip3( 0, pcBaseRec->getWidth () - 1, iCurrPosX + ( (cDv.getHor() + 2 ) >> 2 ) );
@@ -7346,7 +6705,5 @@
 , TComMvField* pcMvFieldSP, UChar* puhInterDirSP
 #endif
-#if SEC_ADAPT_DISABLE_IVMP
 , Bool bICFlag
-#endif
 )
 {
@@ -7377,10 +6734,8 @@
 
   TComMv      cDv = depthRefineFlag ? pDInfo->m_acDoNBDV : pDInfo->m_acNBDV; 
-#if SEC_VER_DONBDV_H0103
   if( depthRefineFlag )
   {
     cDv.setVer(0);
   }
-#endif
 
   Bool abPdmAvailable[8] =  {false, false, false, false, false, false, false, false};
@@ -7392,79 +6747,244 @@
 #endif
 
-#if SEC_ADAPT_DISABLE_IVMP
   if(!bICFlag)
   {
-#endif
 
 #if H_3D_SPIVMP
-  ////////////////////////////////
-  //////////sub-PU IvMC///////////
-  ////////////////////////////////
-  if(!m_pcSlice->getIsDepth())
-  {
-#if MTK_DIS_SPBIP8X4_H0205
-    if (!getDBBPFlag(0))
+    ////////////////////////////////
+    //////////sub-PU IvMC///////////
+    ////////////////////////////////
+    if(!m_pcSlice->getIsDepth())
+    {
+      if (!getDBBPFlag(0))
+      {
+        Int iNumSPInOneLine, iNumSP, iSPWidth, iSPHeight;
+        getSPPara(iWidth, iHeight, iNumSP, iNumSPInOneLine, iSPWidth, iSPHeight);
+
+        for (Int i=0; i<iNumSP; i++)
+        {
+          puhInterDirSP[i] = 0;
+          pcMvFieldSP[2*i].getMv().set(0, 0);
+          pcMvFieldSP[2*i+1].getMv().set(0,0);
+          pcMvFieldSP[2*i].setRefIdx(-1);
+          pcMvFieldSP[2*i+1].setRefIdx(-1);
+        }
+
+        Int         iBaseCUAddr;
+        Int         iBaseAbsPartIdx;
+        TComDataCU* pcBaseCU;
+        Int iPartition = 0;
+
+        Int iDelX = iSPWidth/2;
+        Int iDelY = iSPHeight/2;
+
+        Int         iCenterPosX = iCurrPosX + ( ( iWidth /  iSPWidth ) >> 1 )  * iSPWidth + ( iSPWidth >> 1 );
+        Int         iCenterPosY = iCurrPosY + ( ( iHeight /  iSPHeight ) >> 1 )  * iSPHeight + (iSPHeight >> 1);
+        Int         iRefCenterCUAddr, iRefCenterAbsPartIdx;
+
+        if(iWidth == iSPWidth && iHeight == iSPHeight)
+        {
+          iCenterPosX = iCurrPosX + (iWidth >> 1);
+          iCenterPosY = iCurrPosY + (iHeight >> 1);
+        }
+
+        Int iRefCenterPosX   = Clip3( 0, pcBaseRec->getWidth () - 1, iCenterPosX + ( (cDv.getHor() + 2 ) >> 2 ) );
+        Int iRefCenterPosY   = Clip3( 0, pcBaseRec->getHeight() - 1, iCenterPosY + ( (cDv.getVer() + 2 ) >> 2 ) ); 
+
+        pcBaseRec->getCUAddrAndPartIdx( iRefCenterPosX , iRefCenterPosY , iRefCenterCUAddr, iRefCenterAbsPartIdx );
+        TComDataCU* pcDefaultCU    = pcBasePic->getCU( iRefCenterCUAddr );
+        if(!( pcDefaultCU->getPredictionMode( iRefCenterAbsPartIdx ) == MODE_INTRA ))
+        {
+          for( UInt uiCurrRefListId = 0; uiCurrRefListId < 2; uiCurrRefListId++ )       
+          {
+            RefPicList  eCurrRefPicList = RefPicList( uiCurrRefListId );
+            Bool stopLoop = false;
+            for(Int iLoop = 0; iLoop < 2 && !stopLoop; ++iLoop)
+            {
+              RefPicList eDefaultRefPicList = (iLoop ==1)? RefPicList( 1 -  uiCurrRefListId ) : RefPicList( uiCurrRefListId );
+              TComMvField cDefaultMvField;
+              pcDefaultCU->getMvField( pcDefaultCU, iRefCenterAbsPartIdx, eDefaultRefPicList, cDefaultMvField );
+              Int         iDefaultRefIdx     = cDefaultMvField.getRefIdx();
+              if (iDefaultRefIdx >= 0)
+              {
+                Int iDefaultRefPOC = pcDefaultCU->getSlice()->getRefPOC(eDefaultRefPicList, iDefaultRefIdx);
+                if (iDefaultRefPOC != pcSlice->getPOC())    
+                {
+                  for (Int iPdmRefIdx = 0; iPdmRefIdx < pcSlice->getNumRefIdx( eCurrRefPicList ); iPdmRefIdx++)
+                  {
+                    if (iDefaultRefPOC == pcSlice->getRefPOC(eCurrRefPicList, iPdmRefIdx))
+                    {
+                      abPdmAvailable[ uiCurrRefListId ] = true;
+                      TComMv cMv(cDefaultMvField.getHor(), cDefaultMvField.getVer());
+#if H_3D_NBDV 
+#if H_3D_IV_MERGE
+                      if( !bIsDepth )
+                      {
+#endif
+                        cMv.setIDVFlag   (true);
+                        cMv.setIDVHor    (cDv.getHor());                  
+                        cMv.setIDVVer    (cDv.getVer());  
+                        cMv.setIDVVId    (iViewIndex); 
+#if H_3D_IV_MERGE
+                      }
+#endif
+#endif
+#if !(NTT_BUG_FIX_TK54)
+                      clipMv( cMv );
+#endif
+                      paiPdmRefIdx  [ uiCurrRefListId ] = iPdmRefIdx;
+                      pacPdmMv      [ uiCurrRefListId ] = cMv;
+                      stopLoop = true;
+                      break;
+                    }
+                  }
+                }
+              }
+            }
+          }
+        }
+        availableMcDc[0] = ( abPdmAvailable[0]? 1 : 0) + (abPdmAvailable[1]? 2 : 0);
+
+        if(availableMcDc[0])
+        {
+
+          Int         iBasePosX, iBasePosY;
+          for (Int i=iCurrPosY; i < iCurrPosY + iHeight; i += iSPHeight)
+          {
+            for (Int j = iCurrPosX; j < iCurrPosX + iWidth; j += iSPWidth)
+            {
+              iBasePosX   = Clip3( 0, pcBaseRec->getWidth () - 1, j + iDelX + ( (cDv.getHor() + 2 ) >> 2 ));
+              iBasePosY   = Clip3( 0, pcBaseRec->getHeight() - 1, i + iDelY + ( (cDv.getVer() + 2 ) >> 2 )); 
+
+              pcBaseRec->getCUAddrAndPartIdx( iBasePosX , iBasePosY, iBaseCUAddr, iBaseAbsPartIdx );
+              pcBaseCU    = pcBasePic->getCU( iBaseCUAddr );
+              if(!( pcBaseCU->getPredictionMode( iBaseAbsPartIdx ) == MODE_INTRA ))
+              {
+                for( UInt uiCurrRefListId = 0; uiCurrRefListId < 2; uiCurrRefListId++ )
+                {
+                  RefPicList  eCurrRefPicList = RefPicList( uiCurrRefListId );
+                  Bool bLoop_stop = false;
+                  for(Int iLoop = 0; iLoop < 2 && !bLoop_stop; ++iLoop)
+                  {
+                    RefPicList eBaseRefPicList = (iLoop ==1)? RefPicList( 1 -  uiCurrRefListId ) : RefPicList( uiCurrRefListId );
+                    TComMvField cBaseMvField;
+                    pcBaseCU->getMvField( pcBaseCU, iBaseAbsPartIdx, eBaseRefPicList, cBaseMvField );
+                    Int         iBaseRefIdx     = cBaseMvField.getRefIdx();
+                    if (iBaseRefIdx >= 0)
+                    {
+                      Int iBaseRefPOC = pcBaseCU->getSlice()->getRefPOC(eBaseRefPicList, iBaseRefIdx);
+                      if (iBaseRefPOC != pcSlice->getPOC())    
+                      {
+                        for (Int iPdmRefIdx = 0; iPdmRefIdx < pcSlice->getNumRefIdx( eCurrRefPicList ); iPdmRefIdx++)
+                        {
+                          if (iBaseRefPOC == pcSlice->getRefPOC(eCurrRefPicList, iPdmRefIdx))
+                          {
+                            abPdmAvailable[ uiCurrRefListId ] = true;
+                            TComMv cMv(cBaseMvField.getHor(), cBaseMvField.getVer());
+
+                            if( !bIsDepth )
+                            {
+                              cMv.setIDVFlag   (true);
+                              cMv.setIDVHor    (cDv.getHor());                  
+                              cMv.setIDVVer    (cDv.getVer());  
+                              cMv.setIDVVId    (iViewIndex); 
+                            }
+
+#if !(NTT_BUG_FIX_TK54)
+                            clipMv( cMv );
+#endif
+                            bLoop_stop = true;
+
+                            pcMvFieldSP[2*iPartition + uiCurrRefListId].setMvField(cMv, iPdmRefIdx);
+                            break;
+                          }
+                        }
+                      }
+                    }
+                  }
+                }
+              }
+
+              puhInterDirSP[iPartition] = (pcMvFieldSP[2*iPartition].getRefIdx()!=-1 ? 1: 0) + (pcMvFieldSP[2*iPartition+1].getRefIdx()!=-1 ? 2: 0);
+              if (puhInterDirSP[iPartition] == 0)
+              {
+                puhInterDirSP[iPartition] = availableMcDc[0];
+                pcMvFieldSP[2*iPartition].setMvField(pacPdmMv[0], paiPdmRefIdx[0]);
+                pcMvFieldSP[2*iPartition + 1].setMvField(pacPdmMv[1], paiPdmRefIdx[1]);
+
+              }
+              if (iSPHeight + iSPWidth == 12)
+              {
+                if (puhInterDirSP[iPartition] == 3)
+                {
+                  puhInterDirSP[iPartition] = 1;
+                  pcMvFieldSP[2*iPartition + 1].setMvField(TComMv(0,0), -1);
+                }
+              }
+              iPartition ++;
+            }
+          }
+        }
+      }
+
+      iCurrPosX  += ( iWidth  >> 1 );
+      iCurrPosY  += ( iHeight >> 1 );
+    }
+#endif
+
+    ////////////////////////////////
+    /////// IvMC + IvMCShift ///////
+    ////////////////////////////////
+
+#if H_3D_SPIVMP
+    if(m_pcSlice->getIsDepth())
+    {
+      iCurrPosX  += ( iWidth  >> 1 );
+      iCurrPosY  += ( iHeight >> 1 );
+    }
+    for(Int iLoopCan = ( (m_pcSlice->getIsDepth() || getDBBPFlag(0)) ? 0 : 1 ); iLoopCan < ( 2 - m_pcSlice->getIsDepth() ); iLoopCan ++) 
 #else
-    if( getPartitionSize(0) == SIZE_2Nx2N )
-#endif
-    {
-      Int iNumSPInOneLine, iNumSP, iSPWidth, iSPHeight;
-      getSPPara(iWidth, iHeight, iNumSP, iNumSPInOneLine, iSPWidth, iSPHeight);
-
-      for (Int i=0; i<iNumSP; i++)
-      {
-        puhInterDirSP[i] = 0;
-        pcMvFieldSP[2*i].getMv().set(0, 0);
-        pcMvFieldSP[2*i+1].getMv().set(0,0);
-        pcMvFieldSP[2*i].setRefIdx(-1);
-        pcMvFieldSP[2*i+1].setRefIdx(-1);
-      }
+    for(Int iLoopCan = 0; iLoopCan < 2; iLoopCan ++)
+#endif
+    {
+      // iLoopCan == 0 --> IvMC
+      // iLoopCan == 1 --> IvMCShift 
 
       Int         iBaseCUAddr;
       Int         iBaseAbsPartIdx;
-      TComDataCU* pcBaseCU;
-      Int iPartition = 0;
-
-      Int iDelX = iSPWidth/2;
-      Int iDelY = iSPHeight/2;
-
-      Int         iCenterPosX = iCurrPosX + ( ( iWidth /  iSPWidth ) >> 1 )  * iSPWidth + ( iSPWidth >> 1 );
-      Int         iCenterPosY = iCurrPosY + ( ( iHeight /  iSPHeight ) >> 1 )  * iSPHeight + (iSPHeight >> 1);
-      Int         iRefCenterCUAddr, iRefCenterAbsPartIdx;
-
-      if(iWidth == iSPWidth && iHeight == iSPHeight)
-      {
-        iCenterPosX = iCurrPosX + (iWidth >> 1);
-        iCenterPosY = iCurrPosY + (iHeight >> 1);
-      }
-
-      Int iRefCenterPosX   = Clip3( 0, pcBaseRec->getWidth () - 1, iCenterPosX + ( (cDv.getHor() + 2 ) >> 2 ) );
-      Int iRefCenterPosY   = Clip3( 0, pcBaseRec->getHeight() - 1, iCenterPosY + ( (cDv.getVer() + 2 ) >> 2 ) ); 
-
-      pcBaseRec->getCUAddrAndPartIdx( iRefCenterPosX , iRefCenterPosY , iRefCenterCUAddr, iRefCenterAbsPartIdx );
-      TComDataCU* pcDefaultCU    = pcBasePic->getCU( iRefCenterCUAddr );
-      if(!( pcDefaultCU->getPredictionMode( iRefCenterAbsPartIdx ) == MODE_INTRA ))
-      {
+
+      Int offsetW = (iLoopCan == 0) ? 0 : ( ((iWidth /2)*4) + 4 );
+      Int offsetH = (iLoopCan == 0) ? 0 : ( ((iHeight/2)*4) + 4 );
+
+      Int         iBasePosX   = Clip3( 0, pcBaseRec->getWidth () - 1, iCurrPosX + ( (cDv.getHor() + offsetW + 2 ) >> 2 ) );
+      Int         iBasePosY   = Clip3( 0, pcBaseRec->getHeight() - 1, iCurrPosY + ( (cDv.getVer() + offsetH + 2 ) >> 2 ) ); 
+      pcBaseRec->getCUAddrAndPartIdx( iBasePosX , iBasePosY , iBaseCUAddr, iBaseAbsPartIdx );
+
+      TComDataCU* pcBaseCU    = pcBasePic->getCU( iBaseCUAddr );
+      if(!( pcBaseCU->getPredictionMode( iBaseAbsPartIdx ) == MODE_INTRA ))
+      {
+        // Loop reference picture list of current slice (X in spec). 
         for( UInt uiCurrRefListId = 0; uiCurrRefListId < 2; uiCurrRefListId++ )       
         {
           RefPicList  eCurrRefPicList = RefPicList( uiCurrRefListId );
+
           Bool stopLoop = false;
+          // Loop reference picture list of candidate slice (Y in spec)
           for(Int iLoop = 0; iLoop < 2 && !stopLoop; ++iLoop)
           {
-            RefPicList eDefaultRefPicList = (iLoop ==1)? RefPicList( 1 -  uiCurrRefListId ) : RefPicList( uiCurrRefListId );
-            TComMvField cDefaultMvField;
-            pcDefaultCU->getMvField( pcDefaultCU, iRefCenterAbsPartIdx, eDefaultRefPicList, cDefaultMvField );
-            Int         iDefaultRefIdx     = cDefaultMvField.getRefIdx();
-            if (iDefaultRefIdx >= 0)
+            RefPicList eBaseRefPicList = (iLoop ==1)? RefPicList( 1 -  uiCurrRefListId ) : RefPicList( uiCurrRefListId );
+            TComMvField cBaseMvField;
+            pcBaseCU->getMvField( pcBaseCU, iBaseAbsPartIdx, eBaseRefPicList, cBaseMvField );
+            Int         iBaseRefIdx     = cBaseMvField.getRefIdx();
+            if (iBaseRefIdx >= 0)
             {
-              Int iDefaultRefPOC = pcDefaultCU->getSlice()->getRefPOC(eDefaultRefPicList, iDefaultRefIdx);
-              if (iDefaultRefPOC != pcSlice->getPOC())    
+              Int iBaseRefPOC = pcBaseCU->getSlice()->getRefPOC(eBaseRefPicList, iBaseRefIdx);
+              if (iBaseRefPOC != pcSlice->getPOC())    
               {
                 for (Int iPdmRefIdx = 0; iPdmRefIdx < pcSlice->getNumRefIdx( eCurrRefPicList ); iPdmRefIdx++)
                 {
-                  if (iDefaultRefPOC == pcSlice->getRefPOC(eCurrRefPicList, iPdmRefIdx))
+                  if (iBaseRefPOC == pcSlice->getRefPOC(eCurrRefPicList, iPdmRefIdx))
                   {
-                    abPdmAvailable[ uiCurrRefListId ] = true;
-                    TComMv cMv(cDefaultMvField.getHor(), cDefaultMvField.getVer());
+                    abPdmAvailable[ (uiCurrRefListId + (iLoopCan<<2)) ] = true;
+                    TComMv cMv(cBaseMvField.getHor(), cBaseMvField.getVer());
 #if H_3D_NBDV 
 #if H_3D_IV_MERGE
@@ -7483,6 +7003,6 @@
                     clipMv( cMv );
 #endif
-                    paiPdmRefIdx  [ uiCurrRefListId ] = iPdmRefIdx;
-                    pacPdmMv      [ uiCurrRefListId ] = cMv;
+                    paiPdmRefIdx  [ (uiCurrRefListId + (iLoopCan<<2)) ] = iPdmRefIdx;
+                    pacPdmMv      [ (uiCurrRefListId + (iLoopCan<<2)) ] = cMv;
                     stopLoop = true;
                     break;
@@ -7494,198 +7014,15 @@
         }
       }
-      availableMcDc[0] = ( abPdmAvailable[0]? 1 : 0) + (abPdmAvailable[1]? 2 : 0);
-
-      if(availableMcDc[0])
-      {
-
-        Int         iBasePosX, iBasePosY;
-        for (Int i=iCurrPosY; i < iCurrPosY + iHeight; i += iSPHeight)
-        {
-          for (Int j = iCurrPosX; j < iCurrPosX + iWidth; j += iSPWidth)
-          {
-            iBasePosX   = Clip3( 0, pcBaseRec->getWidth () - 1, j + iDelX + ( (cDv.getHor() + 2 ) >> 2 ));
-            iBasePosY   = Clip3( 0, pcBaseRec->getHeight() - 1, i + iDelY + ( (cDv.getVer() + 2 ) >> 2 )); 
-
-            pcBaseRec->getCUAddrAndPartIdx( iBasePosX , iBasePosY, iBaseCUAddr, iBaseAbsPartIdx );
-            pcBaseCU    = pcBasePic->getCU( iBaseCUAddr );
-            if(!( pcBaseCU->getPredictionMode( iBaseAbsPartIdx ) == MODE_INTRA ))
-            {
-              for( UInt uiCurrRefListId = 0; uiCurrRefListId < 2; uiCurrRefListId++ )
-              {
-                RefPicList  eCurrRefPicList = RefPicList( uiCurrRefListId );
-                Bool bLoop_stop = false;
-                for(Int iLoop = 0; iLoop < 2 && !bLoop_stop; ++iLoop)
-                {
-                  RefPicList eBaseRefPicList = (iLoop ==1)? RefPicList( 1 -  uiCurrRefListId ) : RefPicList( uiCurrRefListId );
-                  TComMvField cBaseMvField;
-                  pcBaseCU->getMvField( pcBaseCU, iBaseAbsPartIdx, eBaseRefPicList, cBaseMvField );
-                  Int         iBaseRefIdx     = cBaseMvField.getRefIdx();
-                  if (iBaseRefIdx >= 0)
-                  {
-                    Int iBaseRefPOC = pcBaseCU->getSlice()->getRefPOC(eBaseRefPicList, iBaseRefIdx);
-                    if (iBaseRefPOC != pcSlice->getPOC())    
-                    {
-                      for (Int iPdmRefIdx = 0; iPdmRefIdx < pcSlice->getNumRefIdx( eCurrRefPicList ); iPdmRefIdx++)
-                      {
-                        if (iBaseRefPOC == pcSlice->getRefPOC(eCurrRefPicList, iPdmRefIdx))
-                        {
-                          abPdmAvailable[ uiCurrRefListId ] = true;
-                          TComMv cMv(cBaseMvField.getHor(), cBaseMvField.getVer());
-
-                          if( !bIsDepth )
-                          {
-                            cMv.setIDVFlag   (true);
-                            cMv.setIDVHor    (cDv.getHor());                  
-                            cMv.setIDVVer    (cDv.getVer());  
-                            cMv.setIDVVId    (iViewIndex); 
-                          }
-                          
-#if !(NTT_BUG_FIX_TK54)
-                          clipMv( cMv );
-#endif
-                          bLoop_stop = true;
-
-                          pcMvFieldSP[2*iPartition + uiCurrRefListId].setMvField(cMv, iPdmRefIdx);
-                          break;
-                        }
-                      }
-                    }
-                  }
-                }
-              }
-            }
-
-            puhInterDirSP[iPartition] = (pcMvFieldSP[2*iPartition].getRefIdx()!=-1 ? 1: 0) + (pcMvFieldSP[2*iPartition+1].getRefIdx()!=-1 ? 2: 0);
-            if (puhInterDirSP[iPartition] == 0)
-            {
-              puhInterDirSP[iPartition] = availableMcDc[0];
-              pcMvFieldSP[2*iPartition].setMvField(pacPdmMv[0], paiPdmRefIdx[0]);
-              pcMvFieldSP[2*iPartition + 1].setMvField(pacPdmMv[1], paiPdmRefIdx[1]);
-
-            }
-#if MTK_DIS_SPBIP8X4_H0205
-            if (iSPHeight + iSPWidth == 12)
-            {
-              if (puhInterDirSP[iPartition] == 3)
-              {
-                puhInterDirSP[iPartition] = 1;
-                pcMvFieldSP[2*iPartition + 1].setMvField(TComMv(0,0), -1);
-              }
-            }
-#endif
-            iPartition ++;
-          }
-        }
-      }
-    }
-
-    iCurrPosX  += ( iWidth  >> 1 );
-    iCurrPosY  += ( iHeight >> 1 );
-  }
-#endif
-
-  ////////////////////////////////
-  /////// IvMC + IvMCShift ///////
-  ////////////////////////////////
-
+    }
 #if H_3D_SPIVMP
-  if(m_pcSlice->getIsDepth())
-  {
-    iCurrPosX  += ( iWidth  >> 1 );
-    iCurrPosY  += ( iHeight >> 1 );
-  }
-#if MTK_DIS_SPBIP8X4_H0205
-  for(Int iLoopCan = ( (m_pcSlice->getIsDepth() || getDBBPFlag(0)) ? 0 : 1 ); iLoopCan < ( 2 - m_pcSlice->getIsDepth() ); iLoopCan ++) 
+    for(Int iLoopCan = ( (m_pcSlice->getIsDepth() || getDBBPFlag(0)) ? 0 : 1 ); iLoopCan < ( 2 - m_pcSlice->getIsDepth() ); iLoopCan ++)
 #else
-  for(Int iLoopCan = ( (m_pcSlice->getIsDepth() || getPartitionSize(uiPartAddr) != SIZE_2Nx2N) ? 0 : 1 ); iLoopCan < ( 2 - m_pcSlice->getIsDepth() ); iLoopCan ++) 
-#endif
-#else
-  for(Int iLoopCan = 0; iLoopCan < 2; iLoopCan ++)
-#endif
-  {
-    // iLoopCan == 0 --> IvMC
-    // iLoopCan == 1 --> IvMCShift 
-
-    Int         iBaseCUAddr;
-    Int         iBaseAbsPartIdx;
-
-    Int offsetW = (iLoopCan == 0) ? 0 : ( ((iWidth /2)*4) + 4 );
-    Int offsetH = (iLoopCan == 0) ? 0 : ( ((iHeight/2)*4) + 4 );
-
-    Int         iBasePosX   = Clip3( 0, pcBaseRec->getWidth () - 1, iCurrPosX + ( (cDv.getHor() + offsetW + 2 ) >> 2 ) );
-    Int         iBasePosY   = Clip3( 0, pcBaseRec->getHeight() - 1, iCurrPosY + ( (cDv.getVer() + offsetH + 2 ) >> 2 ) ); 
-    pcBaseRec->getCUAddrAndPartIdx( iBasePosX , iBasePosY , iBaseCUAddr, iBaseAbsPartIdx );
-
-    TComDataCU* pcBaseCU    = pcBasePic->getCU( iBaseCUAddr );
-    if(!( pcBaseCU->getPredictionMode( iBaseAbsPartIdx ) == MODE_INTRA ))
-    {
-      // Loop reference picture list of current slice (X in spec). 
-      for( UInt uiCurrRefListId = 0; uiCurrRefListId < 2; uiCurrRefListId++ )       
-      {
-        RefPicList  eCurrRefPicList = RefPicList( uiCurrRefListId );
-
-        Bool stopLoop = false;
-        // Loop reference picture list of candidate slice (Y in spec)
-        for(Int iLoop = 0; iLoop < 2 && !stopLoop; ++iLoop)
-        {
-          RefPicList eBaseRefPicList = (iLoop ==1)? RefPicList( 1 -  uiCurrRefListId ) : RefPicList( uiCurrRefListId );
-          TComMvField cBaseMvField;
-          pcBaseCU->getMvField( pcBaseCU, iBaseAbsPartIdx, eBaseRefPicList, cBaseMvField );
-          Int         iBaseRefIdx     = cBaseMvField.getRefIdx();
-          if (iBaseRefIdx >= 0)
-          {
-            Int iBaseRefPOC = pcBaseCU->getSlice()->getRefPOC(eBaseRefPicList, iBaseRefIdx);
-            if (iBaseRefPOC != pcSlice->getPOC())    
-            {
-              for (Int iPdmRefIdx = 0; iPdmRefIdx < pcSlice->getNumRefIdx( eCurrRefPicList ); iPdmRefIdx++)
-              {
-                if (iBaseRefPOC == pcSlice->getRefPOC(eCurrRefPicList, iPdmRefIdx))
-                {
-                  abPdmAvailable[ (uiCurrRefListId + (iLoopCan<<2)) ] = true;
-                  TComMv cMv(cBaseMvField.getHor(), cBaseMvField.getVer());
-#if H_3D_NBDV 
-#if H_3D_IV_MERGE
-                  if( !bIsDepth )
-                  {
-#endif
-                    cMv.setIDVFlag   (true);
-                    cMv.setIDVHor    (cDv.getHor());                  
-                    cMv.setIDVVer    (cDv.getVer());  
-                    cMv.setIDVVId    (iViewIndex); 
-#if H_3D_IV_MERGE
-                  }
-#endif
-#endif
-#if !(NTT_BUG_FIX_TK54)
-                  clipMv( cMv );
-#endif
-                  paiPdmRefIdx  [ (uiCurrRefListId + (iLoopCan<<2)) ] = iPdmRefIdx;
-                  pacPdmMv      [ (uiCurrRefListId + (iLoopCan<<2)) ] = cMv;
-                  stopLoop = true;
-                  break;
-                }
-              }
-            }
-          }
-        }
-      }
-    }
-  }
-#if H_3D_SPIVMP
-#if H_3D_FIX_DBBP_IVMP
-  for(Int iLoopCan = ( (m_pcSlice->getIsDepth() || getDBBPFlag(0)) ? 0 : 1 ); iLoopCan < ( 2 - m_pcSlice->getIsDepth() ); iLoopCan ++)
-#else
-  for(Int iLoopCan = ( 1 - m_pcSlice->getIsDepth() ); iLoopCan < ( 2 - m_pcSlice->getIsDepth() ); iLoopCan ++) 
-#endif
-#else
-  for(Int iLoopCan = 0; iLoopCan < 2; iLoopCan ++)
-#endif
-  {
-    availableMcDc[(iLoopCan << 1)] = ( abPdmAvailable[(iLoopCan<<2)] ? 1 : 0 ) + ( abPdmAvailable[1 + (iLoopCan<<2)] ? 2 : 0);
-  }
-
-#if SEC_ADAPT_DISABLE_IVMP
-  }
-#endif
+    for(Int iLoopCan = 0; iLoopCan < 2; iLoopCan ++)
+#endif
+    {
+      availableMcDc[(iLoopCan << 1)] = ( abPdmAvailable[(iLoopCan<<2)] ? 1 : 0 ) + ( abPdmAvailable[1 + (iLoopCan<<2)] ? 2 : 0);
+    }
+
+  }
 
   ////////////////////////////////
Index: trunk/source/Lib/TLibCommon/TComDataCU.h
===================================================================
--- trunk/source/Lib/TLibCommon/TComDataCU.h	(revision 964)
+++ trunk/source/Lib/TLibCommon/TComDataCU.h	(revision 976)
@@ -70,9 +70,4 @@
   Bool        abMergeFlag[2];       // for two segments
   UChar       auhMergeIndex[2];     // for two segments
-#if !RWTH_DBBP_NO_SPU_H0057
-  Char        ahVSPFlag[2];         // for two segments
-  DisInfo     acDvInfo[2];          // for two segments
-#endif
-  
   PartSize    eVirtualPartSize;
   UInt        uiVirtualPartIndex;
@@ -195,7 +190,5 @@
   Bool*         m_pbSDCFlag;
   Pel*          m_apSegmentDCOffset[2];
-#if HS_DMM_SDC_PREDICTOR_UNIFY_H0108
   Pel          m_apDmmPredictor[2];
-#endif
 #endif
 #endif
@@ -238,5 +231,5 @@
 #endif
 
-#if ETRIKHU_CLEANUP_H0083
+#if H_3D_IV_MERGE
   TComMotionCand  m_mergCands[MRG_IVSHIFT+1];
   Int           m_baseListidc;
@@ -249,23 +242,9 @@
   Bool          xAddMVPCandOrder      ( AMVPInfo* pInfo, RefPicList eRefPicList, Int iRefIdx, UInt uiPartUnitIdx, MVP_DIR eDir );
 #if H_3D_VSP
-#if ETRIKHU_CLEANUP_H0083
   Bool          xAddVspCand( Int mrgCandIdx, DisInfo* pDInfo, Int& iCount);
-#else
-  Bool          xAddVspCand( Int mrgCandIdx, DisInfo* pDInfo, Int& iCount,
-                             Bool* abCandIsInter, TComMvField* pcMvFieldNeighbours, UChar* puhInterDirNeighbours, Int* vspFlag, Int& iCount3DV, InheritedVSPDisInfo*  inheritedVSPDisInfo);
-#endif
 #endif
 #if H_3D_IV_MERGE
-#if ETRIKHU_CLEANUP_H0083
   Bool          xAddIvMRGCand( Int mrgCandIdx, Int& iCount, Int*   ivCandDir, TComMv* ivCandMv, Int* ivCandRefIdx ); 
-#else
-  Bool          xAddIvMRGCand( Int mrgCandIdx, Int& iCount, Bool* abCandIsInter, TComMvField* pcMvFieldNeighbours, UChar* puhInterDirNeighbours, Int*   ivCandDir, TComMv* ivCandMv, 
-                               Int* ivCandRefIdx, Int posIvDC, Int* vspFlag, Int &iCount3DV, InheritedVSPDisInfo*  inheritedVSPDisInfo   ); 
-#endif
-#if ETRIKHU_CLEANUP_H0083
   Bool          xGetPosFirstAvailDmvCand( Int iCount, Int& iFirDispCand );
-#else
-  Bool          xGetPosFirstAvailDmvCand( Int iCount, TComMvField* pcMvFieldNeighbours, Int*  ivCandDir, Int posIvDC, Int* vspFlag, Int& iFirDispCand );
-#endif
 #endif
 
@@ -507,7 +486,4 @@
    
 #if H_3D
-#if !ETRIKHU_CLEANUP_H0083
-  Void          rightShiftMergeCandList( TComMvField* pcMvFieldNeighbours, UChar* puhInterDirNeighbours, Int* iVSPIndexTrue, InheritedVSPDisInfo*  inheritedVSPDisInfo, UInt start, UInt num, Int &iCount3DV);
-#endif
   Bool          getDispforDepth  ( UInt uiPartIdx, UInt uiPartAddr, DisInfo* cDisp);
   Bool          getDispMvPredCan(UInt uiPartIdx, RefPicList eRefPicList, Int iRefIdx, Int* paiPdmRefIdx, TComMv* pacPdmMv, DisInfo* pDis, Int* iPdm );
@@ -532,8 +508,6 @@
 #if H_3D_SPIVMP
     , TComMvField* pcMFieldSP, UChar* puhInterDirSP
-#endif
-#if SEC_ADAPT_DISABLE_IVMP
+#endif    
     , Bool bICFlag
-#endif
     );   
 #endif
@@ -583,10 +557,7 @@
   Pel           getSDCSegmentDCOffset( UInt uiSeg, UInt uiPartIdx ) { return m_apSegmentDCOffset[uiSeg][uiPartIdx]; }
   Void          setSDCSegmentDCOffset( Pel pOffset, UInt uiSeg, UInt uiPartIdx) { m_apSegmentDCOffset[uiSeg][uiPartIdx] = pOffset; }
-#if HS_DMM_SDC_PREDICTOR_UNIFY_H0108
   Void          setDmmPredictor ( Pel pOffset, UInt uiSeg) { m_apDmmPredictor[uiSeg] = pOffset; }
   Pel           getDmmPredictor ( UInt uiSeg) { return m_apDmmPredictor[uiSeg]; }
-#endif
   UInt          getCtxSDCFlag          ( UInt   uiAbsPartIdx );
-  UInt          getCtxAngleFlag        ( UInt   uiAbsPartIdx );
 #endif
 #endif
@@ -666,5 +637,4 @@
   Bool          getAvailableFlagA0() { return m_bAvailableFlagA0;}
   Bool          getAvailableFlagB2() { return m_bAvailableFlagB2;}
-#if ETRIKHU_CLEANUP_H0083
   Void          initAvailableFlags() { m_bAvailableFlagA1 = m_bAvailableFlagB1 = m_bAvailableFlagB0 = m_bAvailableFlagA0 = m_bAvailableFlagB2 = 0;  }
   Void          buildMCL(TComMvField* pcMFieldNeighbours, UChar* puhInterDirNeighbours
@@ -677,7 +647,4 @@
     , Int& numValidMergeCand
     );
-#else
-  Void          initAvailableFlags() { m_bAvailableFlagA1 = m_bAvailableFlagB1 = m_bAvailableFlagB0 = m_bAvailableFlagA0 = m_bAvailableFlagB2 = 0;  }
-#endif
   Void          getInterMergeCandidates( UInt uiAbsPartIdx, UInt uiPUIdx, TComMvField* pcMvFieldNeighbours, UChar* puhInterDirNeighbours, Int& numValidMergeCand, Int mrgCandIdx = -1);
   Void          xGetInterMergeCandidates ( UInt uiAbsPartIdx, UInt uiPUIdx, TComMvField* pcMFieldNeighbours, UChar* puhInterDirNeighbours
@@ -686,15 +653,8 @@
 #endif
 #if H_3D_VSP
-#if !ETRIKHU_CLEANUP_H0083
-                                            , Int* vspFlag
-#endif
                                             , InheritedVSPDisInfo*  inheritedVSPDisInfo
 #endif
 #if H_3D_SPIVMP
-#if ETRIKHU_CLEANUP_H0083
                                             , TComMvField* pcMvFieldSP, UChar* puhInterDirSP
-#else
-                                            , Bool* pbSPIVMPFlag, TComMvField* pcMvFieldSP, UChar* puhInterDirSP
-#endif
 #endif
                                             , Int& numValidMergeCand, Int mrgCandIdx = -1
